<%-- 
    Document   : checkout
    Created on : 28-giu-2016, 2.10.42
    Author     : mirkopoloni
--%>
<%@  taglib  prefix="c"   uri="http://java.sun.com/jsp/jstl/core"  %>
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>Checkout</title>
        <link href="https://fonts.googleapis.com/css?family=Open+Sans:300,400" rel="stylesheet">
        <link rel="stylesheet" type="text/css" href="resources/css/style.css">
    </head>
    <body>
        <div class="left"></div>
        <div class="right"></div>
        <div class="top"></div>
        <div class="bottom"></div>
        <div class="main-wrapper">
            <div class="left-sidebar">
                <div class="left-sidebar-checkout">
                    <h2><a href="Controller">Homepage</a></h2>
                    <c:choose>
                        <c:when test="${cart.size()>0}">
                            <div class="checkout_form_wrapper">
                                <p>Total cost: ${totalCost}€</p>
                                <form method="post">
                                    <input type="text" name="name" required placeholder="Name">
                                    <input type="text" name="surname" required placeholder="Surname">
                                    <input type="text" name="address" required placeholder="Address">
                                    <input type="email" name="email" required placeholder="E-Mail">
                                    <input type="submit" name="buy" value="Buy">
                                </form>
                            </div>
                        </c:when>
                        <c:when test="${confirmation != null && !confirmation.isEmpty()}">
                            <p>${confirmation}</p>
                        </c:when>
                    </c:choose>
                    
                </div>
                
                
            </div>
            <div class="checkout_wrapper">
                <div class="checkout_info_wrapper">
                    <h2>Cart</h2>
                    <p>
                    <c:choose>
                        <c:when test="${cart.size()==0}">
                            Your cart is empty.
                        </c:when>
                        <c:when test="${cart.size()==1}">
                        There is ${cart.size()} product in your cart.
                        </c:when>
                        <c:otherwise>
                        There are ${cart.size()} products in your cart.
                        </c:otherwise>
                    </c:choose>
                    </p>
                </div>
                <c:forEach items="${cart}" var="item">
                        <div class="checkout_items_wrapper">
                            <div class="checkout_item_wrapper">
                                <p>Product: <c:out value="${item.getName()}"/></p>
                                <p>Art.Nr.: <c:out value="${item.getCode()}"/></p>
                                <p>Price for one unit: <c:out value="${item.getPrice()}"/> €</p>
                                <p>Quantity: <c:out value="${item.unitToBuy}"/></p>
                                <p>Total Price: <c:out value="${item.getPrice() * item.unitToBuy}"/> €</p>
                                <form name="frm" method="post" action="">
                                    <input name="delete" type="hidden" value="${item.getCode()}">
                                    <button type="submit" class="button warning">Delete Me</button>
                                </form>
                            </div>
                        </div>
                </c:forEach>
            </div>
        </div>
    </body>
</html>
