/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 * Author:  mirkopoloni
 * Created: 2-lug-2016
 */


DROP DATABASE IF EXISTS onlineshop;
CREATE DATABASE onlineshop;

create user mirkopoloni with password 'root';

\connect onlineshop;

CREATE TABLE PRODUCTS(
   CODE INT NOT NULL UNIQUE,
   NAME VARCHAR(50) NOT NULL,
   DESCRIPTION TEXT NOT NULL,
   MANUFACTURER VARCHAR(50) NOT NULL,
   IMAGE VARCHAR NOT NULL,
   AVAILABILITY INT NOT NULL,
   PRICE DECIMAL(12,2) NOT NULL,
   PRIMARY KEY (CODE)
);

CREATE TABLE CUSTOMERS(
    ID SERIAL,
    NAME VARCHAR(50) NOT NULL,
    SURNAME VARCHAR(50) NOT NULL,
    EMAIL VARCHAR(254) NOT NULL,
    ADDRESS VARCHAR NOT NULL,
    PRIMARY KEY (ID)
);

CREATE TABLE ORDERS(
    ID_ORDER SERIAL,
    CUSTOMER INT NOT NULL REFERENCES CUSTOMERS(ID),
    PRODUCT_CODE INT NOT NULL REFERENCES PRODUCTS(CODE),
    QUANTITY INT NOT NULL,
    PRICE DECIMAL(12,2) NOT NULL,
    PRIMARY KEY (ID_ORDER)
);

GRANT ALL ON PRODUCTS TO mirkopoloni;
GRANT ALL ON CUSTOMERS TO mirkopoloni;
GRANT ALL ON ORDERS TO mirkopoloni;
GRANT ALL ON CUSTOMERS_ID_SEQ TO mirkopoloni;
GRANT ALL ON ORDERS_ID_ORDER_SEQ TO mirkopoloni;

INSERT INTO PRODUCTS VALUES ( 1343, 'PonoPlayer - High Resolution Audio Player', 'Pono is the culmination of Neil Young’s goal to bring the quality of music that he and other artists experience in the studio to everyone. Pono plays high-resolution music files and other formats better than any portable device. While the Pono Player looks simple, it contains discreet analog circuitry and the highest quality components never before used in a portable player. That circuitry was taken straight from the world renowned Ayre Acoustic’s own top-of-the-line products. It’s the key to providing unparalleled sound quality and unrivaled listening pleasure. The difference is the breadth and depth, as well as the full dimensionality of the music that’s much more open than compressed music files.', 'PonoMusic', '/resources/images/pono.jpg', 100, 399.49  );
INSERT INTO PRODUCTS VALUES ( 2343, 'ZANO - Autonomous. Intelligent. Nano Drone.', 'ZANO is an ultra-portable, personal aerial photography and HD video capture platform, Small enough to fit in the palm of your hand and intelligent enough to fly all by itself! ZANO connects directly to your smart device (iOS or Android)  via onboard WiFi and enables you to instantly begin capturing and sharing moments like never before.', 'Torquing Group Ltd', '/resources/images/zano.jpg', 50, 189.90 );
INSERT INTO PRODUCTS VALUES ( 6834, 'BOOSTED BOARD', 'The Boosted Single drive was designed for portability. We adapted its one-motor system from our original two-motor design and used an upgraded motor for strong power. New electronics are rated for 1000 watts of power and precise acceleration up to 18 mph. The board can climb up a 15% grade and has regenerative braking that charges the battery as you slow down. We lightened the board to 13.5 pounds to make it even more portable than before. Finally, we increased range to seven miles. We will ship a limited run in January before we enter full production, and you can pre-order today at $999.', 'BOOSTED', '/resources/images/boosted.jpg', 230, 999.00 );
INSERT INTO PRODUCTS VALUES ( 8793, 'Ably™ - T-Shirt', 'Unbelievably odor & stain repellant natural apparel - Ably’s 100% premium cotton shirts and hoodies shrug off water, stains, and odor so you can get into your dirtiest fun and still look and smell fresh. Go ahead, Nature Boy—camp for a week with only one shirt. Go for it, Gym Queen—work out for an hour on the elliptical and still smell like daisies. It’s time to think of all the stuff you can do with your time besides laundry. Ably Apparel is activated with Filium™, a technology that makes natural fabrics repel liquids, stains, and odors. The first time we saw our prototypes in action, we had to pick our jaws off the floor. Pour water on an Ably shirt, spill coffee or wine, and it just beads up and rolls off like it’s on glass.', 'Ably Apparel', '/resources/images/ably.jpg', 1000, 48.00 );
INSERT INTO PRODUCTS VALUES ( 4944, 'Wynd - The smartest air purifier', 'Wynd creates a bubble of clean air around you by removing dust, allergens, smoke, and pollution from your personal space. Since it filters harmful particles out of the air around you, Wynd helps you breathe clean air and feel refreshed. Wynd isn’t just an air purifier—it’s an intelligent personal air quality system. It monitors your environment and cleans as needed. Wynd is the size of a water bottle, so it’s easy to use anywhere—in offices, hotels, cars, public transportation, and more. Wynd helps you breathe easy wherever you go.', 'Wynd Technologies, Inc.', '/resources/images/wynd.jpg', 1034, 139.00 );
INSERT INTO PRODUCTS VALUES ( 3632, 'VanMoof - SmartBike', 'The smartest thing on wheels. The VanMoof SmartBike is unlike any other bike. Not only will it ship with anti-theft parts and tracking that make it terrifying to bike thieves. If a thief is brilliant enough to get past all that, we promise to get your stolen bike back to you in two weeks, or we will replace it. We call this the VanMoof Peace of Mind Service, and every SmartBike gets it totally free of charge for the first two years. Not only is the SmartBike a nightmare for thieves. It is also been designed to be the ultimate city bike. Unlike most bikes that get rustier with time, this one will get smarter over time, thanks to all the tech packed inside the frame and a dedicated smartphone app. It’s totally keyless, and can be unlocked with the tap of a finger on a smartphone or even the touch of a hand on the bike. It’ll even make sure you arrive dry, with smartphone weather notifications personalized to your commute.', 'VanMoof',  '/resources/images/vanmoof.jpg', 10, 1398.00 );
INSERT INTO PRODUCTS VALUES ( 8736, 'The Basslet: a wearable subwoofer for your body', 'The Basslet is a wearable subwoofer for your body. Using a whole new technology for sound, it delivers the beats and basslines of your music directly to you – so you can literally feel the music. The result is a powerful sound experience that headphones alone cannot provide. The Basslet is a masterpiece of engineering. It puts the power and accuracy of a large sound system into a device that fits on your wrist. It is completely silent to the outside world – and despite the size, it makes you feel like you are surrounded by sound.', 'Lofelt', '/resources/images/basslet.jpg', 450, 129.00 );
INSERT INTO PRODUCTS VALUES ( 4754, 'Bagel: The Smartest Tape Measure', 'Bagel is a digital tape measure that helps you measure, organize, and analyze any size measurements in a smart way. Bagel is the only tape measure you will ever need. With three different measuring modes, Bagel lets you measure just about anything. It can also save measurements, record voice memos, and send data to its mobile app, where you can easily organize and analyze your measurements. That’s why we call Bagel a smart tape measure.', 'Bagel Labs, Inc.', '/resources/images/bagel.jpg', 120, 69.00 );
INSERT INTO PRODUCTS VALUES ( 2148, 'Boie USA: The Toothbrush of the future', 'Antimicrobial, non abrasive toothbrush made from a medical grade elastomer that lasts twice as long as a nylon bristled toothbrush. Traditional toothbrushes are abrasive, dirty, and wasteful. Something that we use twice a day, everyday, should be better than that. This has lead us to develop a toothbrush that is functional, clean and environmentally friendly.', 'Boie USA', '/resources/images/boie.jpg', 1000, 12.00 );
INSERT INTO PRODUCTS VALUES ( 5467, 'Nura - Headphones', 'We’re living in a golden age where masterfully crafted, recorded and engineered music is at our fingertips. But the journey of music doesn’t end at the smartphone. The journey completes with you, the listener. Nura is a new headphone that integrates unique soundwave technology to automatically measure your hearing (from the outer ear all the way to the brain) and adapt music perfectly to you. You do not need to answer any tests either - just sit back and listen. In order for headphones to deliver the right sound, they must be matched to the listener. Nura even recognizes you when you put them on.', 'Nura', '/resources/images/nura.png', 500, 399.00 );
INSERT INTO PRODUCTS VALUES ( 8962, 'Aer Travel Pack: The Ultimate Carry-on Backpack', 'Never check your bag again. Pack all your essentials in the ultimate carry-on travel backpack designed to keep you moving. The Travel Pack is our take on the ultimate carry-on backpack for the smart traveler. Our goal was to create a bag that keeps you moving so you can have the best travel experience possible.', 'Aer', '/resources/images/aer.jpg', 123, 159.00 );
INSERT INTO PRODUCTS VALUES ( 3446, 'SmartHalo - TURN YOUR BIKE INTO A SMART BIKE', 'NEVER GET LOST AGAIN. SmartHalo finds the quickest and safest routes and bikepaths for you, to make your ride a stress-free experience. Input the destination on your smartphone, tuck it safely back in your pocket and let SmartHalo take care of the rest. Get turn-by-turn navigation straight on your handlebar, like a bike GPS, but simply through an intuitive light halo. Alleluia.', 'SmartHalo', '/resources/images/smarthalo.png', 50, 139.00 );
INSERT INTO PRODUCTS VALUES ( 1957, 'Robin. The smarter smartphone.', 'We’re Nextbit. We made a smartphone that brings the power of the cloud to everyone with an integrated cloud OS. We made it because we’re tired of waiting on others. Because we believe in a cloud-first future. And because no one else was making the phone we wanted. This is the phone we want, and we think you’ll want it too. Smarter. Powerful. Bold. And, direct to you. Now we need your help. Back us to help make next a reality now.', 'Nextbit', '/resources/images/robin.png', 2000, 299.00 );
INSERT INTO PRODUCTS VALUES ( 7552, 'Prepd Pack - The Lunchbox Reimagined', 'Lunchtime: It’s the most difficult time of the day to control what you eat. Eating out, or getting takeout, can get costly — and it’s virtually impossible to know exactly what’s inside your food. That is why we created the Prepd Pack, a revolutionary new take on the humble lunchbox. From planning and preparing your lunches, to tracking your food’s nutritional value, Prepd Pack and its integrative app makes the entire process easier, more enjoyable, and less wasteful. Beautifully designed, Prepd Pack is uncompromisingly modern, consisting of a main case that houses a versatile modular system of containers and smart magnetic cutlery. The removable modular containers are central to Prepd’s functionality — corresponding to each day’s needs, these individual food compartments can be combined in multiple configurations within the Prepd Pack. Made from the highest-quality materials, the containers are food-safe and completely leak-proof.', 'Prepd', '/resources/images/prepd.png', 5000, 50.00 );

