/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package OnlineShop;

import java.io.IOException;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpSession;


/**
 *
 * @author mirkopoloni
 */
@WebServlet(name = "Checkout", urlPatterns = {"/Checkout"})
public class CheckoutController extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        String url = "/WEB-INF/view/checkout.jsp";
        
        
        //ServletContext holen
        ServletContext sc = this.getServletContext();
        
        String orderXmlVerzeichnis = sc.getRealPath("WEB-INF/xml/order.xml");
        String customerXmlVerzeichnis = sc.getRealPath("WEB-INF/xml/customer.xml");
        
        
        
        HttpSession session = request.getSession();
        ArrayList <Item> cart = (ArrayList) session.getAttribute("cart");
        double totalCost = 0;
        String confirmation = null;
        
        // Delete an item from the cart if the delete button is pressed   
        if (request.getParameter("delete") != null && !request.getParameter("delete").isEmpty()) {
            int productNumber = Integer.parseInt(request.getParameter("delete"));
            confirmation = null;
            for (Item singleItem : cart) { 
                if (singleItem.getCode() == productNumber ) { 
                    cart.remove(singleItem);
                    session.setAttribute("cart", cart);
                    break;
                }
            }
        }
        
        
        // If the user click on the buy button, the items will be bought
        String action = request.getParameter("buy");

        if (action != null && cart.size() > 0) {
            String name = request.getParameter("name");
            String surname = request.getParameter("surname");
            String address = request.getParameter("address");
            String email = request.getParameter("email");
            // Save the user infos in a customer object
            CustomerKlasse customer = new CustomerKlasse();
            customer.setName(name);
            customer.setSurname(surname);
            customer.setAddress(address);
            customer.setMail(email);
            XMLZugriff xmlz = new XMLZugriff();
            xmlz.addOrders(cart, orderXmlVerzeichnis);
            xmlz.addCustomer(customer, customerXmlVerzeichnis);
            // Items bought
            // The cart has now to be empty...
            cart = new ArrayList<> ();
            session.setAttribute("cart", cart);
            confirmation = "Perfect! You have bought your items!";
            
        }
        
        // Update the total price of the cart if there are items available for the purchase
        if (cart.size() > 0) {
            for (Item singleItem : cart) { 
                double itemCost = singleItem.getUnitToBuy() * singleItem.getPrice();
                totalCost = totalCost + itemCost;
            }
            session.setAttribute("totalCost", totalCost);
        }
        session.setAttribute("confirmation", confirmation);
        
        
        RequestDispatcher rd = sc.getRequestDispatcher(url);
        rd.forward(request, response);
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}

