/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package OnlineShop;

import generated.Product;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpSession;


/**
 *
 * @author mirkopoloni
 */
@WebServlet(name = "Controller", urlPatterns = {"/Controller"})
public class Controller extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        String url = "/WEB-INF/view/index.jsp";
        
        //ServletContext holen
        ServletContext sc = this.getServletContext();
        
        String xmlVerzeichnis = sc.getRealPath("WEB-INF/xml/product.xml");
        System.out.println(xmlVerzeichnis);
        
        
        
        HttpSession session = request.getSession();
        String filter;
        
        // Look if the the arraylist cart exists or create a new one
        if (session.getAttribute("cart") == null) {
            ArrayList <Item> cart = new ArrayList<> ();
            session.setAttribute("cart", cart);
        } else {
            ArrayList cart = (ArrayList) session.getAttribute("cart");
        }
              
        XMLZugriff xmlz = new XMLZugriff();
        List<Item> ItemList = xmlz.deSerializeProductList(xmlVerzeichnis);
        session.setAttribute("ItemList", ItemList);
        ArrayList<String> ManufacturerList = xmlz.deSerializeManufacturerList(xmlVerzeichnis);
        session.setAttribute("ManufacturerList", ManufacturerList);
        int arraySize = ManufacturerList.size();
        session.setAttribute("arraySize", arraySize);
        
        
        // Filter the items' list 
        filter = request.getParameter("filter"); 
        if (filter != null) {
            System.out.println(filter);
            ItemList = xmlz.filterItems(xmlVerzeichnis, filter);
            request.setAttribute("ItemList", ItemList);
        } 
            
        
        RequestDispatcher rd = sc.getRequestDispatcher(url);
        rd.forward(request, response);
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
