/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package OnlineShop;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.sql.Statement;
import java.sql.ResultSet;
import java.util.ArrayList;

/**
 *
 * @author mirkopoloni
 */
public class DBConnection {
    
    Connection connection;
    Statement statement;
    ResultSet resultSet;
    String sqlQuery;
    String host;
    String username;
    String password;

    public DBConnection() {
        try {
            Class.forName("org.postgresql.Driver");
            
            host = "jdbc:postgresql:onlineshop";
            username = "mirkopoloni";
            password = "root";
            
            connection = DriverManager.getConnection(host, username, password);
            statement = connection.createStatement( );
            

        } catch (SQLException | ClassNotFoundException ex) {
            Logger.getLogger(DBConnection.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }
    
    public ArrayList retrieveItems() {
        ArrayList <Item> ItemList = new ArrayList<> ();
        Item nextItem;
        try {
            
            sqlQuery = "SELECT * FROM products";

            PreparedStatement preparedStatement = this.connection.prepareStatement( sqlQuery );            
            
            resultSet = preparedStatement.executeQuery();
            while ( this.resultSet.next( ) ) {
                nextItem = new Item();
                nextItem.setAvailability(resultSet.getInt("availability"));
                nextItem.setPrice(resultSet.getDouble("price"));
                nextItem.setCode(resultSet.getInt("code"));
                nextItem.setName(resultSet.getString("name"));
                nextItem.setDescription(resultSet.getString("description"));
                nextItem.setManufacturer(resultSet.getString("manufacturer"));
                nextItem.setImage(resultSet.getString("image"));
                
                ItemList.add(nextItem);
            }
            resultSet.close();
        } catch (SQLException ex) {
            Logger.getLogger(DBConnection.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return ItemList;
        
    }
    
    
    public ArrayList filterItems(String hersteller) {
        ArrayList <Item> ItemList = new ArrayList<> ();
        Item nextItem;
        try {
            
            sqlQuery = "SELECT * FROM products";
            PreparedStatement preparedStatement = this.connection.prepareStatement( sqlQuery );            
            
            resultSet = preparedStatement.executeQuery();
            while ( this.resultSet.next( ) ) {
                if (hersteller.equals(resultSet.getString("manufacturer"))) {
                    nextItem = new Item();
                    nextItem.setAvailability(resultSet.getInt("availability"));
                    nextItem.setPrice(resultSet.getDouble("price"));
                    nextItem.setCode(resultSet.getInt("code"));
                    nextItem.setName(resultSet.getString("name"));
                    nextItem.setDescription(resultSet.getString("description"));
                    nextItem.setManufacturer(resultSet.getString("manufacturer"));
                    nextItem.setImage(resultSet.getString("image"));
                    ItemList.add(nextItem);
                }
                
            }
            resultSet.close();
        } catch (SQLException ex) {
            Logger.getLogger(DBConnection.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return ItemList;
        
    }
    
    
    public ArrayList manufacturerList() {
        ArrayList <String> ManufacturerList = new ArrayList<> ();
        String nextManufacturer;
        try {
            
            sqlQuery = "SELECT manufacturer FROM products";
            PreparedStatement preparedStatement = this.connection.prepareStatement( sqlQuery );            
            
            resultSet = preparedStatement.executeQuery();
            while ( this.resultSet.next( ) ) {
                nextManufacturer = resultSet.getString("manufacturer");
                
                if(!ManufacturerList.contains(nextManufacturer)) {
                    ManufacturerList.add(nextManufacturer);
                }             
                
            }
            resultSet.close();
        } catch (SQLException ex) {
            Logger.getLogger(DBConnection.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return ManufacturerList;
        
    }
    
    public Item itemDetailPage( int itemNumber) {
        Item theItem = null;
        try {
            
            sqlQuery = "SELECT * FROM products WHERE code =?";
            PreparedStatement preparedStatement = this.connection.prepareStatement( sqlQuery );            
            preparedStatement.setInt(1, itemNumber);
            resultSet = preparedStatement.executeQuery();
            while ( this.resultSet.next( ) ) {
                theItem = new Item();
                theItem.setAvailability(resultSet.getInt("availability"));
                theItem.setPrice(resultSet.getDouble("price"));
                theItem.setCode(resultSet.getInt("code"));
                theItem.setName(resultSet.getString("name"));
                theItem.setDescription(resultSet.getString("description"));
                theItem.setManufacturer(resultSet.getString("manufacturer"));
                theItem.setImage(resultSet.getString("image"));
                
            }
            resultSet.close();
        } catch (SQLException ex) {
            Logger.getLogger(DBConnection.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return theItem;
        
    }
    
    public void addCustomer( CustomerKlasse customer ) {
        
        try {
            
            sqlQuery = "INSERT INTO CUSTOMERS (NAME, SURNAME, ADDRESS, EMAIL) VALUES (?,?,?,?)";
            PreparedStatement preparedStatement = this.connection.prepareStatement( sqlQuery );            
            preparedStatement.setString(1, customer.getName());
            preparedStatement.setString(2, customer.getSurname());
            preparedStatement.setString(3, customer.getAddress());
            preparedStatement.setString(4, customer.getMail());
            resultSet = preparedStatement.executeQuery();
            resultSet.close();
        } catch (SQLException ex) {
            Logger.getLogger(DBConnection.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }
    
    public void updateItemsQuantity( ArrayList <Item> items ) {
        
        for (Item singleItem : items) { 
            int itemCode = singleItem.getCode();
            int itemAvailability = singleItem.getAvailability();
            int itemToBuy = singleItem.getUnitToBuy();
            int newItemAvailability = itemAvailability - itemToBuy;
            try {
        
                sqlQuery = "UPDATE PRODUCTS SET AVAILABILITY = ? WHERE CODE = ?";
                PreparedStatement preparedStatement = this.connection.prepareStatement( sqlQuery );
                preparedStatement.setInt(1, newItemAvailability);
                preparedStatement.setInt(2, itemCode);
                resultSet = preparedStatement.executeQuery();
                resultSet.close();
            } catch (SQLException ex) {
                Logger.getLogger(DBConnection.class.getName()).log(Level.SEVERE, null, ex);
            }
            
        }  
    }
    
    public void addOrders( ArrayList<Item> items) {
        for (Item singleItem : items) { 
            int itemCode = singleItem.getCode();
            double itemPrice = singleItem.getPrice();
            int itemToBuy = singleItem.getUnitToBuy();
            singleItem.setUnitToBuy(0);
            try {
        
                sqlQuery = "INSERT INTO ORDERS (CUSTOMER, PRODUCT_CODE, QUANTITY, PRICE) VALUES ((SELECT MAX(ID) FROM CUSTOMERS),?,?,?)";
                PreparedStatement preparedStatement = this.connection.prepareStatement( sqlQuery );
                preparedStatement.setInt(1, itemCode);
                preparedStatement.setInt(2, itemToBuy);
                preparedStatement.setDouble(3, itemPrice);
                resultSet = preparedStatement.executeQuery();
                resultSet.close();
            } catch (SQLException ex) {
                Logger.getLogger(DBConnection.class.getName()).log(Level.SEVERE, null, ex);
            }
            
        } 
    }
    
}
