/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package OnlineShop;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpSession;


/**
 *
 * @author mirkopoloni
 */
@WebServlet(name = "Detail", urlPatterns = {"/Detail"})
public class DetailController extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        String url = "/WEB-INF/view/detail.jsp";
        
        //ServletContext holen
        ServletContext sc = this.getServletContext();
        
        String xmlVerzeichnis = sc.getRealPath("WEB-INF/xml/product.xml");
        
        HttpSession session = request.getSession();
        int itemQuantity;
        int itemNumber;
        boolean itemAlreadyAdded = false;
        String succeed;
        ArrayList <Item> cart = (ArrayList) session.getAttribute("cart");
        
        
        // Retrieve infos from database for the selected item    
        if (request.getParameter("number") != null && !request.getParameter("number").isEmpty()) {
            int productNumber = Integer.parseInt(request.getParameter("number"));
            //DBConnection dbc = new DBConnection();
            //Item item = dbc.itemDetailPage( productNumber );
            XMLZugriff xmlz = new XMLZugriff();
            Item item = xmlz.itemDetailPage( productNumber, xmlVerzeichnis );
            session.setAttribute("item", item);
        }
        
        // Check if the item was already bought
        if (session.getAttribute("item") != null) {
            Item item = (Item) session.getAttribute("item");
            if (cart.size() > 0) {
                itemAlreadyAdded = false;
                for (Item singleItem : cart) {
                    if (singleItem.getCode() == item.getCode() ) {
                        session.setAttribute("item", singleItem);
                        itemAlreadyAdded = true;
                        break;
                    }
                }
            }
        }
        
        // If the user decides to buy the item and clicks on the submit button...
        if (request.getParameter("itemQuantity") == null) {
            succeed = null;
        } else if (request.getParameter("itemQuantity").isEmpty()) { 
            succeed = "There was a problem with your request... item quantity?";
        } else {
            // Check which item the user would like to buy and how many units
            Item item = (Item) session.getAttribute("item");      
            itemQuantity = Integer.parseInt(request.getParameter("itemQuantity"));
            if (itemAlreadyAdded) {
                if (itemQuantity > 0 && item.checkAvailability(itemQuantity)) {
                    // Item already bought and quantity ok...
                    succeed = "Units updated.";                        
                    item.setUnitToBuy( item.getUnitToBuy() + itemQuantity);
                } else {
                    // Item already bought but quantity not ok...
                    succeed = "You've already bought the product and we haven't so many units to sell you, please try again with a lower number of units.";
                }
            } else {
                if (itemQuantity > 0 && item.checkAvailability(itemQuantity)) {
                    // Item not in the cart yet and quantity ok...
                    succeed = "Everything's ok, product added to your cart.";
                    Item itemToAdd = item;
                    itemToAdd.setUnitToBuy(itemQuantity);
                    cart.add(itemToAdd);
                }  else {
                    // Item not in the cart yet and quantity not ok...
                    succeed = "There was a problem with your request... item quantity?";
                }
            }   
        }   
        session.setAttribute("succeed", succeed);
        session.setAttribute("cart", cart);
            

        
        RequestDispatcher rd = sc.getRequestDispatcher(url);
        rd.forward(request, response);
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
