/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package OnlineShop;

import generated.ObjectFactory;
import generated.Order;
import generated.Product;
import generated.Customer;
import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;

/**
 *
 * @author mirkopoloni
 */
public class XMLZugriff {
    
    private ObjectFactory objF;
    private Product product;
    
    public XMLZugriff() {
        objF = new generated.ObjectFactory();
    }
    
    public List deSerializeProductList(String path) {

        List<generated.Product.Row> productList = null;

        try {
            
            File file = new File(path);
            JAXBContext jaxbContext = JAXBContext.newInstance(Product.class);
            
            Unmarshaller jaxbUnmarshaller = jaxbContext.createUnmarshaller();
            Product newProduct = (Product) jaxbUnmarshaller.unmarshal(file);


            //liste fuellen
            productList = newProduct.getRow();

        } catch (Exception e) {
            e.printStackTrace();
        }

        return productList;
    }
    
    public ArrayList deSerializeManufacturerList(String path) {

        ArrayList <String> ManufacturerList = new ArrayList<> ();
        String nextManufacturer;
        XMLZugriff xmlz = new XMLZugriff();
        List<Product.Row> productList = xmlz.deSerializeProductList(path);
        
        for(Product.Row actualProduct : productList) {
            nextManufacturer = actualProduct.getManufacturer();
            if(!ManufacturerList.contains(nextManufacturer)) {
                ManufacturerList.add(nextManufacturer);
            }
        }
        
        return ManufacturerList;
    }
    
    public ArrayList filterItems(String path, String manufacturer) {

        ArrayList <Item> FilteredItemList = new ArrayList<> ();
        Item nextItem;
        XMLZugriff xmlz = new XMLZugriff();
        List<Product.Row> productList = xmlz.deSerializeProductList(path);
        
        for(Product.Row actualProduct : productList) {
        
            if (manufacturer.equals(actualProduct.getManufacturer())) {
                nextItem = new Item();
                nextItem.setAvailability(actualProduct.getAvailability());
                nextItem.setPrice(actualProduct.getPrice());
                nextItem.setCode(actualProduct.getCode());
                nextItem.setName(actualProduct.getName());
                nextItem.setDescription(actualProduct.getDescription());
                nextItem.setManufacturer(actualProduct.getManufacturer());
                nextItem.setImage(actualProduct.getImage());
                FilteredItemList.add(nextItem);
            }
        }
        
        return FilteredItemList;
    }
    
    
    public Item itemDetailPage( int itemNumber, String path) {
        Item theItem = null;
        
        XMLZugriff xmlz = new XMLZugriff();
        List<Product.Row> productList = xmlz.deSerializeProductList(path);
        
        for(Product.Row actualProduct : productList) {
        
            if (itemNumber == actualProduct.getCode()) {
                theItem = new Item();
                theItem.setAvailability(actualProduct.getAvailability());
                theItem.setPrice(actualProduct.getPrice());
                theItem.setCode(actualProduct.getCode());
                theItem.setName(actualProduct.getName());
                theItem.setDescription(actualProduct.getDescription());
                theItem.setManufacturer(actualProduct.getManufacturer());
                theItem.setImage(actualProduct.getImage());
            }
        }
        
        return theItem;
        
    }
    
    public void addCustomer( CustomerKlasse customer, String path ) {
        
        try {

            File file = new File(path);
            JAXBContext jaxbContext = JAXBContext.newInstance(generated.Customer.class);
            Unmarshaller unmarshaller = jaxbContext.createUnmarshaller();
            Marshaller jaxbMarshaller = jaxbContext.createMarshaller();
            
            generated.Customer customerResult = (generated.Customer) unmarshaller.unmarshal(file);
            
            jaxbMarshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);            
            
            generated.Customer.Row row = new Customer.Row();
                
            row.setName(customer.getName());
            row.setSurname(customer.getSurname());
            row.setAddress(customer.getAddress());
            row.setEmail(customer.getMail());
            row.setId(new Random().nextInt());
            
            customerResult.getRow().add(row);
            
            jaxbMarshaller.marshal(customerResult, file);
            

        } catch (JAXBException e) {
          e.printStackTrace();
        }
        
    }
    
    
    public void addOrders( ArrayList<Item> items, String path) {
        
        
        try {

            File file = new File(path);
            JAXBContext jaxbContext = JAXBContext.newInstance(generated.Order.class);
            Unmarshaller unmarshaller = jaxbContext.createUnmarshaller();
            Marshaller jaxbMarshaller = jaxbContext.createMarshaller();
            
            generated.Order orderResult = (generated.Order) unmarshaller.unmarshal(file);
            
            jaxbMarshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
            
            int customerId = new Random().nextInt();
            
            for (Item singleItem : items) { 
                int itemCode = singleItem.getCode();
                double itemPrice = singleItem.getPrice();
                int itemToBuy = singleItem.getUnitToBuy();
                singleItem.setUnitToBuy(0);
                
                generated.Order.Row row = new Order.Row();
                
                row.setCustomer(customerId);
                row.setProductCode(itemCode);
                row.setPrice(itemPrice);
                row.setQuantity(itemToBuy);
                row.setId(new Random().nextInt());
                orderResult.getRow().add(row);

            }
            
            jaxbMarshaller.marshal(orderResult, file);
            

        } catch (JAXBException e) {
          e.printStackTrace();
        }
   
    }
    
    
    public static void main(String[] args) {
        //https://www.mkyong.com/java/jaxb-hello-world-example/
        //COnvert object to xml, prova a inserire un xml
        
        
        
        
	

    }
    
}
